
//`define  IMG_TYPE_720P
module img_data_gen
(
    input             i_clk         ,//clock
    input             i_rst_n       ,//reset
    //Output Data
    input [ 7:0]     i_pixel0      ,
    input [ 7:0]     i_pixel1      ,
    input [ 7:0]     i_pixel2      ,
    input [ 7:0]     i_pixel3      ,
    input [ 7:0]     i_pixel4      ,
    input [ 7:0]     i_pixel5      ,
    input [ 7:0]     i_pixel6      ,
    input [ 7:0]     i_pixel7      ,
    input [ 7:0]     i_pixel8      ,
    input [ 7:0]     i_pixel9      ,
    input [ 7:0]     i_pixel10     ,
    input [ 7:0]     i_pixel11     ,
    input [ 7:0]     i_pixel12     ,
    input [ 7:0]     i_pixel13     ,
    input [ 7:0]     i_pixel14     ,
    input [ 7:0]     i_pixel15     ,
    input            i_d_sync      ,
    input            i_h_sync      ,
    input            i_v_sync      ,

	output           o_v_sync      ,
	output           o_h_sync      ,
	output           o_d_sync      ,
    output[15:0]     o_pixel_dout    

);
parameter S0      = 8'd0;
parameter S1      = 8'd1;
parameter S2      = 8'd2;
parameter S3      = 8'd4; 
parameter S4      = 8'd8; 
parameter S5      = 8'd16; 
`ifdef IMG_TYPE_720P  
    parameter H_NUM   = 16'd720; 
    //parameter D_NUM   = 16'd1280;   
    parameter D_NUM   = 16'd640;   
`else
    parameter H_NUM   = 16'd1080; 
    //parameter D_NUM   = 16'd1920; 
    parameter D_NUM   = 16'd960;  
`endif  
parameter DELAY_VAL   = 16'd2; 
  
  
wire [127:0] Data_i;
wire [15: 0] o_pixel_dout_bf;
reg         r_v_sync;
reg         r_h_sync;
reg         r_d_sync;


reg [15:0] r_d_cnt;
reg [15:0] r_h_cnt;
reg [15:0] r_v_cnt;
reg [15:0] r_h_cnt2;

reg        r_line_valid_rev;
reg [15:0] r_line_number;

wire [10:0] w_ada_i;
wire [10:0] w_adb_i;
reg  [10:0] r_ada_i;
reg  [10:0] adb_i;
reg  [15:0] din_i;
wire [15:0] dout_o;
reg         r_cea;
reg         r_cea_bf;
reg         r_wr_sdpb_switch;
reg         r_wr_sdpb_switch_bf;
reg         r_rd_sdpb_switch;

reg  [ 7:0] wr_sdpb_state;
reg  [ 7:0] wr_sdpb_data_cnt;

reg  [ 7:0] i_pixel0_bf;
reg  [ 7:0] i_pixel1_bf;
reg  [ 7:0] i_pixel2_bf;
reg  [ 7:0] i_pixel3_bf;
reg  [ 7:0] i_pixel4_bf;
reg  [ 7:0] i_pixel5_bf;
reg  [ 7:0] i_pixel6_bf;
reg  [ 7:0] i_pixel7_bf;
reg  [ 7:0] i_pixel8_bf;
reg  [ 7:0] i_pixel9_bf;
reg  [ 7:0] i_pixel10_bf;
reg  [ 7:0] i_pixel11_bf;
reg  [ 7:0] i_pixel12_bf;
reg  [ 7:0] i_pixel13_bf;
reg  [ 7:0] i_pixel14_bf;
reg  [ 7:0] i_pixel15_bf;


reg  [ 7:0] rd_state;
reg  [ 7:0] wr_state;
reg  [15:0] wr_delay_cnt;
 

//128
assign Data_i = {i_pixel15[7:0],i_pixel14[7:0],i_pixel13[7:0],i_pixel12[7:0],
                    i_pixel11[7:0],i_pixel10[7:0],i_pixel9[7:0],i_pixel8[7:0],
                    i_pixel7[7:0],i_pixel6[7:0],i_pixel5[7:0],i_pixel4[7:0],
                    i_pixel3[7:0],i_pixel2[7:0],i_pixel1[7:0],i_pixel0[7:0]
                    };

assign o_v_sync = ~r_v_sync;
assign o_h_sync = ~r_h_sync;
assign o_d_sync = r_d_sync;

Gowin_SDPB_Img Gowin_SDPB_Img_u0(
    .dout(o_pixel_dout_bf), //output [15:0] dout
    .clka(i_clk), //input clka
    .cea(r_cea_bf), //input cea
    .clkb(i_clk), //input clkb
    .ceb(1'b1), //input ceb
    .oce(1'b0), //input oce
    .reset(!i_rst_n), //input reset
    .ada(w_ada_i), //input [10:0] ada
    .din(din_i), //input [15:0] din
    .adb(w_adb_i) //input [10:0] adb
);

assign o_pixel_dout   = o_pixel_dout_bf;
//addr
assign w_ada_i = (r_wr_sdpb_switch == 1'b0)? r_ada_i : (11'd1024 + r_ada_i);
assign w_adb_i = (r_rd_sdpb_switch == 1'b0)? r_d_cnt[10:0] : (11'd1024 + r_d_cnt[10:0]);

reg [15:0]  r_line_cnt ;
reg         r_h_sync_in ;  
reg         r_v_sync_in ;
reg         r_line_valid;
always@(posedge i_clk or negedge i_rst_n) begin
    if(~i_rst_n) begin
        r_line_cnt <= 16'b0;
        r_line_valid <= 1'b0;
    end
    else begin
        r_h_sync_in <= i_h_sync;
        r_v_sync_in <= i_v_sync;
        if({r_v_sync_in,i_v_sync} == 2'b01) begin
            r_line_cnt <= 16'd0;
        end
        else if({r_h_sync_in,i_h_sync} == 2'b01) begin
            r_line_cnt <= r_line_cnt + 1'b1;
        end
        else begin
            r_line_cnt <= r_line_cnt ;
        end


        if(r_line_cnt == 16'd62) begin
            r_line_valid <= 1'b1;
        end
        else if({r_v_sync_in,i_v_sync} == 2'b10) begin
            r_line_valid <= 1'b0;
        end
    end
end


//wr sdpb
always@(posedge i_clk or negedge i_rst_n)
begin
	if(!i_rst_n) begin
        din_i <= 16'd0;
    end
	else begin
        if( r_line_valid == 1'b1)begin
            case(wr_sdpb_data_cnt)
                8'd0: din_i <= {i_pixel1_bf[7:0],i_pixel0_bf[7:0]};
                8'd1: din_i <= {i_pixel3_bf[7:0],i_pixel2_bf[7:0]};
                8'd2: din_i <= {i_pixel5_bf[7:0],i_pixel4_bf[7:0]};
                8'd3: din_i <= {i_pixel7_bf[7:0],i_pixel6_bf[7:0]};
                8'd4: din_i <= {i_pixel9_bf[7:0],i_pixel8_bf[7:0]};
                
                8'd5: din_i <= {i_pixel11_bf[7:0],i_pixel10_bf[7:0]};
                8'd6: din_i <= {i_pixel13_bf[7:0],i_pixel12_bf[7:0]};
                8'd7: din_i <= {i_pixel15_bf[7:0],i_pixel14_bf[7:0]};
                default:
                begin 
                    din_i <= 16'd0;
                end
            endcase
        end

	end
end
//wr sdpb data
always@(posedge i_clk or negedge i_rst_n)
begin
	if(!i_rst_n) begin
		r_cea <= 1'd0;
		r_ada_i <= 11'd0;
        r_wr_sdpb_switch <= 1'd0;
        wr_sdpb_data_cnt <= 8'd0;
        wr_sdpb_state <= S0;
    end
	else begin
        r_cea_bf <= r_cea;
        r_wr_sdpb_switch_bf <= r_wr_sdpb_switch;
        case(wr_sdpb_state)
            S0:
            begin //wait
                r_ada_i <= 11'd0;
                r_cea <= 1'd0;
                if(i_h_sync == 1'd1 && r_line_valid == 1'd1) begin
                    r_line_valid_rev <= 1'b1;
                    wr_sdpb_state <= S1;
                end
                else begin
                    r_line_valid_rev <= 1'b0;
                    wr_sdpb_state <= S0;
                end
            end
            
            S1:
            begin //detect
                i_pixel0_bf <= i_pixel0;
                i_pixel1_bf <= i_pixel1;
                i_pixel2_bf <= i_pixel2;
                i_pixel3_bf <= i_pixel3;
                i_pixel4_bf <= i_pixel4;
                i_pixel5_bf <= i_pixel5;
                i_pixel6_bf <= i_pixel6;
                i_pixel7_bf <= i_pixel7;
                i_pixel8_bf <= i_pixel8;
                i_pixel9_bf <= i_pixel9; 
                
                i_pixel10_bf <= i_pixel10;
                i_pixel11_bf <= i_pixel11;
                i_pixel12_bf <= i_pixel12;
                i_pixel13_bf <= i_pixel13;
                i_pixel14_bf <= i_pixel14;
                i_pixel15_bf <= i_pixel15;

                wr_sdpb_data_cnt <= 8'd0;
                if(i_h_sync == 1'd0) begin
                    r_cea <= 1'd0;
                    r_wr_sdpb_switch <= ~r_wr_sdpb_switch;
                    wr_sdpb_state <= S0;
                end
                else if(i_d_sync & r_line_valid_rev) begin
                    r_cea <= 1'd1;
                    wr_sdpb_state <= S2;
                end
                else begin
                    r_cea <= 1'd0;
                    wr_sdpb_state <= S1;
                end
            end

            S2:
            begin //wait
                r_ada_i <= r_ada_i + 1'b1;
                if((wr_sdpb_data_cnt == 8'd7) && (i_d_sync & r_line_valid_rev) == 1'b1) begin
                    i_pixel0_bf <= i_pixel0;
                    i_pixel1_bf <= i_pixel1;
                    i_pixel2_bf <= i_pixel2;
                    i_pixel3_bf <= i_pixel3;
                    i_pixel4_bf <= i_pixel4;
                    i_pixel5_bf <= i_pixel5;
                    i_pixel6_bf <= i_pixel6;
                    i_pixel7_bf <= i_pixel7;
                    i_pixel8_bf <= i_pixel8;
                    i_pixel9_bf <= i_pixel9; 
                    
                    i_pixel10_bf <= i_pixel10;
                    i_pixel11_bf <= i_pixel11;
                    i_pixel12_bf <= i_pixel12;
                    i_pixel13_bf <= i_pixel13;
                    i_pixel14_bf <= i_pixel14;
                    i_pixel15_bf <= i_pixel15;

                    r_cea <= 1'd1;
                    wr_sdpb_data_cnt <= 8'd0;
                    wr_sdpb_state <= S2;
                end
                else if((wr_sdpb_data_cnt == 8'd7) && (i_d_sync & r_line_valid_rev) == 1'b0) begin
                    r_cea <= 1'd0;
                    wr_sdpb_data_cnt <= 8'd0;
                    wr_sdpb_state <= S1;
                end
                else begin
                    r_cea <= 1'd1;
                    wr_sdpb_data_cnt <= wr_sdpb_data_cnt + 1'b1;
                    wr_sdpb_state <= S2;
                end
            end
    
            default:
            begin 
                wr_sdpb_state <= S0;
            end
        endcase

	end
end


//rd sdpb data
always @(posedge i_clk or negedge i_rst_n)
begin
	if(~i_rst_n)
	begin
        r_v_sync <= 1'b0; 
        r_h_sync <= 1'b0; 
        r_d_sync <= 1'b0; 
        r_d_cnt <= 16'd0;
        r_h_cnt <= 16'd0;
		wr_delay_cnt <= 16'd0;
        wr_state <= S5;
	end
	else begin
        case(wr_state)
            S0:
            begin //h
                r_d_sync <= 1'b0;
                r_rd_sdpb_switch <= ~r_wr_sdpb_switch;
                if(r_wr_sdpb_switch_bf != r_wr_sdpb_switch) begin
                    r_v_sync <= 1'b1; 
                    wr_state <= S1;
                end
                else begin
                    r_v_sync <= 1'b0; 
                    wr_state <= S0;
                end
            end
            
            S1:
            begin //delay
                r_h_sync <= 1'b1; 
                if( wr_delay_cnt == DELAY_VAL )begin
                    wr_delay_cnt <= 16'd0;
                    wr_state <= S2;
                end
                else begin
                    wr_delay_cnt <= wr_delay_cnt + 1'b1;
                    wr_state <= S1;
                end
            end

            S2:
            begin //detect,  valid data start
                if( r_d_cnt == D_NUM )begin
                    r_d_cnt <= 16'd0;
                    r_d_sync <= 1'b0; 
                    r_h_cnt <= r_h_cnt + 1'b1;
                    wr_state <= S3;
                end
                else begin
                    r_d_sync <= 1'b1; 
                    r_d_cnt <= r_d_cnt + 1'b1;
                    wr_state <= S2;
                end
            end

            S3:
            begin //delay
                if( wr_delay_cnt == DELAY_VAL )begin
                    wr_delay_cnt <= 16'd0;
                    wr_state <= S4;
                end
                else begin
                    wr_delay_cnt <= wr_delay_cnt + 1'b1;
                    wr_state <= S3;
                end
            end

            S4: //r_h_cnt2
            begin //detect,  
                r_h_sync <= 1'b0;
                if( r_h_cnt == H_NUM )begin
                    wr_state <= S5;
                end
                else begin
                    wr_state <= S0;
                end
            end

            S5:
            begin //detect
                r_h_cnt <= 16'd0;
                if(i_v_sync == 1'd0) begin
                    r_v_sync <= 1'b0; 
                    wr_state <= S0;
                end
                else begin
                    r_v_sync <= 1'b1; 
                    wr_state <= S5;
                end
            end
 
            default:
            begin 
                wr_state <= S5;
            end
        endcase
    end

end


endmodule       
              