//===========================================================================
// Module name: led_test.v
//===========================================================================
`timescale 1ns / 1ps
module led_test 
(  
sys_clk,          //system clock 
rst_n,              // reset ,low active            
led_out              // LED,use for control the LED signal on board
);            
//===========================================================================
// PORT declarations
//===========================================================================
input           sys_clk;
input           rst_n;
output          led_out;

//define the time counter
reg [31:0]      timer;                  
reg [3:0]       led;
wire            sys_clk;          


assign led_out = led[0];
//===========================================================================
// cycle counter:from 0 to 1sec
//===========================================================================
always @(posedge sys_clk or negedge rst_n)    
begin
  if (~rst_n)                           
      timer <= 32'd0;                     // when the reset signal valid,time counter clearing
  else if (timer == 32'd12_999_999)    //4 seconds count(12M-1=11999999)
      timer <= 32'd0;                       //count done,clearing the time counter
  else
      timer <= timer + 1'b1;            //timer counter = timer counter + 1
end
//===========================================================================
// LED control
//===========================================================================
always @(posedge sys_clk or negedge rst_n)   
begin
  if (~rst_n)                      
      led <= 4'b0000;                  //when the reset signal active         
  else if (timer == 32'd12_999_999/4)    //time counter count to 0.25 sec,LED1 lighten 
      led <= 4'b0001;                 
  else if (timer == 32'd12_999_999/2)    //time counter count to 0.5 sec,LED2lighten
  begin
      led <= 4'b0010;                  
    end
  else if (timer == 32'd12_999_999 *3/4)   //time counter count to 0.75 sec,LED3 lighten
      led <= 4'b0100;                                          
  else if (timer == 32'd12_999_999)   //time counter count to 1 sec,LED4 lighten
      led <= 4'b1000;                         
end   
endmodule