
module gowin_rom  #(
    parameter RAM_WIDTH = 24,
    parameter RAM_DEPTH = 1024,
    parameter INIT_FILE = "./parameter_prom.txt"

)
(
input                           clk_i,
input [$clog2(RAM_DEPTH)-1:0]   addr_i,
output reg [RAM_WIDTH-1:0]      dout_o
);
localparam                      ADDR_WIDTH = $clog2(RAM_DEPTH);

reg [RAM_WIDTH-1:0]             mem_data[0:2**ADDR_WIDTH-1];


initial
begin
    $readmemh(INIT_FILE,mem_data,0,2**ADDR_WIDTH-1);
end

always@(posedge clk_i) begin
    dout_o <= mem_data[addr_i];
end


endmodule //Gowin_ROM
